--
-- Rainwhiper
-- Specialization for Rainwhiper
--
-- @author  Manuel Leithner
-- @date  18/12/2011
--
-- frei verwendbar - keine erlaubnis nötig  |  free for use - no permission needed.
-- Modifikationen erst nach Rücksprache!    |  modifications only with my permission.
--
-- Hinweis: das kopieren von Sourcecode ist strafbar nach UrhG §2.1
-- 

scheibenwischer = {};
function scheibenwischer.prerequisitesPresent(specializations)
    return true
end;

function scheibenwischer:load(xmlFile)

    local wiperAnimRootNode = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.wiper#rootNode"));
    self.wiperAnimCharSet = 0;
    if wiperAnimRootNode ~= nil and wiperAnimRootNode ~= 0 then
        self.wiperAnimCharSet = getAnimCharacterSet(wiperAnimRootNode);
        if self.wiperAnimCharSet ~= 0 then
            local clip = getAnimClipIndex(self.wiperAnimCharSet, getXMLString(xmlFile, "vehicle.wiper#clip"));
            assignAnimTrackClip(self.wiperAnimCharSet, 0, clip);
            setAnimTrackLoopState(self.wiperAnimCharSet, 0, true);
            local wiperAnimSpeedScale = Utils.getNoNil(getXMLFloat(xmlFile, "vehicle.wiper#speedScale"), 1);
			setAnimTrackSpeedScale(self.wiperAnimCharSet, 0, wiperAnimSpeedScale);
            self.wiperAnimDuration = getAnimClipDuration(self.wiperAnimCharSet, clip);
		end;
    end;
	self.isWiperActive = false;
	self.finishWiper = true;
	self.scheibenwischer = false;
	
	local wiperSound = getXMLString(xmlFile, "vehicle.wiperSound#file");
	if wiperSound ~= nil and wiperSound ~= "" then
		wiperSound = Utils.getFilename(wiperSound, self.baseDirectory); 
		self.wiperSound = createSample("wiperSound");
		self.wiperSoundEnabled = false;
		loadSample(self.wiperSound, wiperSound, false);
		self.wiperSoundPitchOffset = Utils.getNoNil(getXMLFloat(xmlFile, "vehicle.wiperSound#pitchOffset"), 1);
		self.wiperSoundVolume = Utils.getNoNil(getXMLFloat(xmlFile, "vehicle.wiperSound#volume"), 1);
	end; 
end;

function scheibenwischer:delete()
end;

function scheibenwischer:mouseEvent(posX, posY, isDown, isUp, button)
end;

function scheibenwischer:keyEvent(unicode, sym, modifier, isDown)
end;

function scheibenwischer:readStream(streamId, connection)
end;

function scheibenwischer:writeStream(streamId, connection)
end;

function scheibenwischer:update(dt)
       if self:getIsActiveForInput() then
           if InputBinding.hasEvent(InputBinding.scheibenwischer) then
				self.scheibenwischer = not self.scheibenwischer;
	        end;
	    end;
end;

function scheibenwischer:updateTick(dt)

		if not self.finishWiper then
			if getAnimTrackTime(self.wiperAnimCharSet, 0) % self.wiperAnimDuration <= 100 then
				setAnimTrackTime(self.wiperAnimCharSet, 0, 0.0);
				disableAnimTrack(self.wiperAnimCharSet, 0);
				stopSample(self.wiperSound, 0, 1.6, 0);
				self.finishWiper = true;
			end;			
		end;
		if self.scheibenwischer and self:getIsActive() then
			if not self.isWiperActive then
				enableAnimTrack(self.wiperAnimCharSet, 0);
				playSample(self.wiperSound, 0, 1.6, 0);
				self.isWiperActive = true;
			end;
		else
			if self.isWiperActive then
				self.isWiperActive = false;
				self.finishWiper = false;
			end;
		end;
		
		for _, part in pairs(self.movingParts) do
			part.isDirty = true;
		end;
end;

function scheibenwischer:draw()
	if self.scheibenwischer == false then
		g_currentMission:addHelpButtonText(g_i18n:getText("wiperON"), InputBinding.scheibenwischer);
	else
		g_currentMission:addHelpButtonText(g_i18n:getText("wiperOFF"), InputBinding.scheibenwischer);
	end;
end;			

function scheibenwischer:onLeave()

	if self.isWiperActive then
		disableAnimTrack(self.wiperAnimCharSet, 0);	
		stopSample(self.wiperSound, 0, 1.6, 0);
	end;
end;	

function scheibenwischer:onEnter()

	if self.isWiperActive then
		enableAnimTrack(self.wiperAnimCharSet, 0);	
		playSample(self.wiperSound, 0, 1.6, 0);
	end;
end;
